/*
 * The following source code ("Code") may only be used in accordance with the terms
 * and conditions of the license agreement you have with IBM Corporation. The Code 
 * is provided to you on an "AS IS" basis, without warranty of any kind.  
 * SUBJECT TO ANY STATUTORY WARRANTIES WHICH CAN NOT BE EXCLUDED, IBM MAKES NO 
 * WARRANTIES OR CONDITIONS EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
 * TO, THE IMPLIED WARRANTIES OR CONDITIONS OF MERCHANTABILITY, FITNESS FOR A 
 * PARTICULAR PURPOSE, AND NON-INFRINGEMENT, REGARDING THE CODE. IN NO EVENT WILL 
 * IBM BE LIABLE TO YOU OR ANY PARTY FOR ANY DIRECT, INDIRECT, SPECIAL OR OTHER 
 * CONSEQUENTIAL DAMAGES FOR ANY USE OF THE CODE, INCLUDING, WITHOUT LIMITATION, 
 * LOSS OF, OR DAMAGE TO, DATA, OR LOST PROFITS, BUSINESS, REVENUE, GOODWILL, OR 
 * ANTICIPATED SAVINGS, EVEN IF IBM HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH 
 * DAMAGES. SOME JURISDICTIONS DO NOT ALLOW THE EXCLUSION OR LIMITATION OF 
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES, SO THE ABOVE LIMITATION OR EXCLUSION MAY 
 * NOT APPLY TO YOU.
 */

/*
 * IBM-MDMWB-1.0-[7590d3870ca8671415458472d2749dc4]
 */

package com.ibm.x.behaviour;


import com.dwl.base.DWLCommon;
import com.dwl.base.extensionFramework.ClientJavaExtensionSet;
import com.dwl.base.extensionFramework.ExtensionParameters;
import com.dwl.base.logging.DWLLoggerManager;
import com.dwl.base.logging.IDWLLogger;
import com.dwl.tcrm.exception.TCRMException;
import com.ibm.im.rdm.notifications.InvokeNotification;
import com.ibm.im.rdm.notifications.SerializableExtensionParameters;

import ejbs.MyTimer;

import javax.naming.Context;
import javax.naming.InitialContext;


/**
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 *
 * This is a Java rule that extends the behavior of WCC. @see
 * com.dwl.base.extensionFramework.ClientJavaExtensionSet
 * 
 * @generated
 */
public class RDValue extends ClientJavaExtensionSet {

	private static final IDWLLogger logger = DWLLoggerManager.getLogger(RDValue.class);
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 *
	 * The execute method will be called in case of extension activation.
	 *
	 * @generated not
	 */
	public void execute(ExtensionParameters params) {



		logger.finest("## start X RDValue BehExt");

		try {
			callCustomNotification(params);
			//callTimer(params);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		params.setSkipExecutionFlag(true);
		logger.finest("## end X RDValue BehExt");
	}


	private void callCustomNotification(ExtensionParameters params) throws Exception {
		new InvokeNotification().sendNotification( params.getControl() );
	}


	private  void callTimer(ExtensionParameters arg0) throws Exception {


		try {

			SerializableExtensionParameters sep = new SerializableExtensionParameters();
			sep.setActionType(arg0.getActionType());
			sep.setTransactionType(arg0.getTransactionType());
			sep.setControl(arg0.getControl());
			sep.setTransactionObjectHierarchy(((DWLCommon) arg0.getTransactionObjectHierarchy()));
			sep.setTriggerCategoryType(arg0.getTriggerCategoryType());
			sep.setParameters(arg0.getParameters());
			sep.setFullyQualifiedBehaviourExtensionName(this.getClass().getName());

			logger.finest("## ActionType in BehExt: "+sep.getActionType());

			Context ctx = new InitialContext();
			Object object = ctx.lookup("ejblocal:ejbs/MyTimer"); //java:comp/env/myTimer");
			MyTimer myTimer = (MyTimer) object;
			myTimer.fireTimer(sep);
		} catch (Exception e) {
			e.printStackTrace();
		}


	}

}



